diff options
author | Junio C Hamano <gitster@pobox.com> | 2007-07-07 13:38:06 -0700 |
---|---|---|
committer | Junio C Hamano <gitster@pobox.com> | 2007-07-07 13:38:06 -0700 |
commit | 6abe0f0383a9b77266810df0d1109b6d0783906e (patch) | |
tree | fbc1100c5d30e4a496fb1513017cb666fa371547 | |
parent | e3c76dbd0f7531eaed3ca8ec0000f03499839304 (diff) | |
parent | 150937c42591b0e9fb6c17f96c459d57b5f3bfdb (diff) | |
download | git-6abe0f0383a9b77266810df0d1109b6d0783906e.tar.gz git-6abe0f0383a9b77266810df0d1109b6d0783906e.tar.xz |
Merge branch 'js/stash'
* js/stash:
Teach git-stash to "apply --index"
-rwxr-xr-x | git-stash.sh | 21 | ||||
-rwxr-xr-x | t/t3903-stash.sh | 69 |
2 files changed, 89 insertions, 1 deletions
diff --git a/git-stash.sh b/git-stash.sh index 7b1638c68..eac555138 100755 --- a/git-stash.sh +++ b/git-stash.sh @@ -112,6 +112,13 @@ apply_stash () { git diff-files --quiet || die 'Cannot restore on top of a dirty state' + unstash_index= + case "$1" in + --index) + unstash_index=t + shift + esac + # current index state c_tree=$(git write-tree) || die 'Cannot apply a stash in the middle of a merge' @@ -121,6 +128,15 @@ apply_stash () { b_tree=$(git rev-parse --verify "$s^:") || die "$*: no valid stashed state found" + test -z "$unstash_index" || { + git diff --binary $s^2^..$s^2 | git apply --cached + test $? -ne 0 && + die 'Conflicts in index. Try without --index.' + unstashed_index_tree=$(git-write-tree) || + die 'Could not save index tree' + git reset + } + eval " GITHEAD_$w_tree='Stashed changes' && GITHEAD_$c_tree='Updated upstream' && @@ -138,9 +154,12 @@ apply_stash () { die "Cannot unstage modified files" git-status rm -f "$a" + test -z "$unstash_index" || git read-tree $unstashed_index_tree else # Merge conflict; keep the exit status from merge-recursive - exit + status=$? + test -z "$unstash_index" || echo 'Index was not unstashed.' >&2 + exit $status fi } diff --git a/t/t3903-stash.sh b/t/t3903-stash.sh new file mode 100755 index 000000000..392ac1c5c --- /dev/null +++ b/t/t3903-stash.sh @@ -0,0 +1,69 @@ +#!/bin/sh +# +# Copyright (c) 2007 Johannes E Schindelin +# + +test_description='Test git-stash' + +. ./test-lib.sh + +test_expect_success 'stash some dirty working directory' ' + echo 1 > file && + git add file && + test_tick && + git commit -m initial && + echo 2 > file && + git add file && + echo 3 > file && + test_tick && + git stash && + git diff-files --quiet && + git diff-index --cached --quiet HEAD +' + +cat > expect << EOF +diff --git a/file b/file +index 0cfbf08..00750ed 100644 +--- a/file ++++ b/file +@@ -1 +1 @@ +-2 ++3 +EOF + +test_expect_success 'parents of stash' ' + test $(git rev-parse stash^) = $(git rev-parse HEAD) && + git diff stash^2..stash > output && + diff -u output expect +' + +test_expect_success 'apply needs clean working directory' ' + echo 4 > other-file && + git add other-file && + echo 5 > other-file + ! git stash apply +' + +test_expect_success 'apply stashed changes' ' + git add other-file && + test_tick && + git commit -m other-file && + git stash apply && + test 3 = $(cat file) && + test 1 = $(git show :file) && + test 1 = $(git show HEAD:file) +' + +test_expect_success 'apply stashed changes (including index)' ' + git reset --hard HEAD^ && + echo 6 > other-file && + git add other-file && + test_tick && + git commit -m other-file && + git stash apply --index && + test 3 = $(cat file) && + test 2 = $(git show :file) && + test 1 = $(git show HEAD:file) +' + +test_done |